--
-- Created by IntelliJ IDEA.
-- User: momo
-- Date: 2018/7/25
-- Time: 10:34 AM
-- To change this template use File | Settings | File Templates.
--

-- 过期代码

xe = xe or xes
ar = ar or AR
xe.App = xe.App or {}
xe.App.Platform = xe.Director:GetPlatform()
xe.PLATFORM_OS_NONE = 0
xe.PLATFORM_OS_IOS = 1
xe.PLATFORM_OS_ANDROID = 2

function xe.Scene:ctor(sceneID)
    local instasnce = xe.Scene:CreateScene(sceneID)

    instasnce.StartTick = function()
        print_warning("xe.Scene:StartTick方法已过期")
    end
    instasnce.startTick = instasnce.StartTick
    instasnce.StopTick = function()
        print_warning("xe.Scene:StopTick方法已过期")
    end

    return instasnce
end

function xe:Class(...)
    print_warning("xe:Class 已被标记过期 请尽快使用 xe.XClass 代替")
    return xe.XClass('UnnamedClass', ...)
end

function xe.XClass(classname, ...)
    local clazz = { XClassName = classname }

    local supers = { ... }
    for _, super in ipairs(supers) do
        local superType = type(super)
        if superType == "function" then
            clazz.__create = super
        elseif superType == "table" then
            if super.isCClass then
                -- super is native class
                clazz.__create = function(...)
                    return super:ctor(...)
                end
            else
                -- super is pure lua class
                clazz.__supers = clazz.__supers or {}
                clazz.__supers[#clazz.__supers + 1] = super
                if not clazz.super then
                    -- set first super pure lua class as class.super
                    clazz.super = super
                end
            end
        else
            print_warning(string.format("class() - create class \"%s\" with invalid super type", classname), 0)
        end
    end

    clazz.__index = clazz
    if not clazz.__supers or #clazz.__supers == 1 then
        setmetatable(clazz, { __index = clazz.super })
    else
        setmetatable(clazz, { __index = function(_, key)
            local supers = clazz.__supers
            for i = 1, #supers do
                local super = supers[i]
                if super[key] then
                    return super[key]
                end
            end
        end })
    end

    function clazz:new(...)
        local instance
        if clazz.__create then
            instance = clazz.__create(...)
        else
            instance = {}
        end
        setmetatableindex(instance, clazz)
        instance.class = clazz
        if instance.onCreate then
            instance:onCreate(...)
        end
        return instance
    end

    return clazz
end

XLuaClass = xe.XClass

XFaceRigBoneControl = xFaceRigBoneControl
XFaceRigControllerInfo = xFaceRigControllerInfo
ModelAnimController = XEAnimatableModelComponent.ModelAnimController
FaceRigAnimController = XEAnimatableFaceRigComponent.FaceRigAnimController
XBoneRenderData = XBone.XBoneRenderData
XBoneState = XBone.BoneState


for k, v in pairs(_G) do
    if type(v) == 'table' then
        if v.isCClass then
            xe[k] = v
        end
    end
end